function s = mispecgramm(S, M, Bs, Z)
% MISPECGRAM Compute inverse masked spectrogram
% SIGNAL = MISPECGRAMM(SPECTROGRAM, MASK, BLOCK_SKIP, FILTERLENGTH)

B = (size(S,1)-1)*2;
nB = size(S,2);
s = zeros((nB-1)*Bs+B,1);
w = [hanning(B-Z); zeros(Z,1)];
s_win = zeros((nB-1)*Bs+B,1);

for b = 1:nB
    m = M(:,b);
    bfilt = fir2(Z, linspace(0,1,length(m))', m)';
    Bfilt = fft([bfilt; zeros(B-length(bfilt),1)]);
    xsig = [S(:,b); conj(S(end-1:-1:2,b))] .* Bfilt;
    x = ifft(xsig);
    s(Bs*(b-1)+(1:B)) = s(Bs*(b-1)+(1:B)) + x;
    s_win(Bs*(b-1)+(1:B)) = s_win(Bs*(b-1)+(1:B)) + w;
    drawnow;
end
s_win(s_win<eps)=eps;
s_win = s_win.^-1;
s_win(1:(B-Z)/2) = s_win(1:(B-Z)/2).*w(1:(B-Z)/2);
s_win(end-(B+Z)/2+1:end) = s_win(end-(B+Z)/2+1:end).*w((B-Z)/2+1:end);
s = real(s .* s_win);